SetDirectory["Z:/home/helene/INVERSION/sta24_all/RESULT/res0ST24/"]
proj=StringDrop[FileNames["*.rf"][[1]],-3];
pref=StringReplace[Directory[],{ParentDirectory[]->"","/"->"",proj->""}];

 dir0 = "./"; 
outdir = "./"; 
  outfil = StringJoin[pref, proj, "s"]; 

rat = 1.2; 
dptrng = -150; 
Print["rat=",rat,", depth=",dptrng];

<< "Graphics`MultipleListPlot`"

color = True; 

If[color, suff = ""; clf = If[#1 <= 0.3, Hue[0, 0, 1], 
       Hue[0.75*(1 - #1)]] & , suff = ""; 
    clf = If[#1 == 0, Hue[0, 0, 1], GrayLevel[1 - #1]] & ]; 

athick = AbsoluteThickness[1.5]; 

adash = AbsoluteDashing[{2, 4}]; 

dir1 = StringJoin["../",pref, proj, "1/"]; 
dir2 = StringJoin["../",pref, proj, "2/"]; 
dir3 = StringJoin["../",pref, proj, "3/"]; 


ReadObs[srcdir_, obsfnm_] := Block[{fnm, t1, dt, tb, tbx, i, span}, 
    fnm = OpenRead[StringJoin[srcdir, obsfnm]]; t1 = Read[fnm, Number]; 
     dt = Read[fnm, Number]; tb = ReadList[fnm, Number]; Close[fnm]; 
     tbx = Table[(i - 1)*dt + t1, {i, 1, Length[tb]}]; 
     span = Max[tb] - Min[tb]; gobs1 = ListPlot[Transpose[{tbx, tb}], 
       PlotJoined -> True, PlotStyle -> {GrayLevel[1], Thickness[0.02], 
         Dashing[{0.01, 0.02}]}, Frame -> True, GridLines -> Automatic, 
       PlotRange -> {Min[tb] - span/1, Max[tb] + span/2}, AspectRatio -> 1/5, 
       DisplayFunction -> Identity]; gobs2 = ListPlot[Transpose[{tbx, tb}], 
       PlotJoined -> True, PlotStyle -> {GrayLevel[0], athick, adash}, 
       Frame -> True, GridLines -> Automatic, PlotRange -> 
        {Min[tb] - span/1, Max[tb] + span/1}, AspectRatio -> 1/5, 
       DisplayFunction -> Identity]; 
     Return[{If[color, Show[gobs2, DisplayFunction -> Identity], 
        Show[gobs1, gobs2, DisplayFunction -> Identity]], Length[tb], 
       t1, tbx, tb}]]; 

Off[General::spell1]

Off[General::spell]

SelectData[dir_, fnm_, numrecs_, wavelen_, rat_] := 
  Block[{datatb, i, tolP, tolSV, tolTP, tolTS, datatb1, fs}, 
   fs = OpenRead[StringJoin[dir, fnm]]; datatb = Table[0, {numrecs}]; 
    For[i = 1, i <= numrecs, i++, datatb[[i]] = 
      Read[fs, {Table[Number, {7}], Table[Number, {wavelen}]}]]; Close[fs]; 
    tolP = Sort[Transpose[Transpose[datatb][[1]]][[2]]][[
      Round[numrecs/rat]]]; 
    tolSV = Sort[Transpose[Transpose[datatb][[1]]][[3]]][[
      Round[numrecs/rat]]]; 
    tolTP = Sort[Transpose[Transpose[datatb][[1]]][[4]]][[
      Round[numrecs/rat]]]; 
    tolTS = Sort[Transpose[Transpose[datatb][[1]]][[5]]][[
      Round[numrecs/rat]]]; Print[StringJoin["tolP=", ToString[tolP], 
      ", tolSV=", ToString[tolSV], ", tolTP=", ToString[tolTP], ", tolTS=", 
      ToString[tolTS]]]; datatb1 = Select[datatb, 
      #1[[1,2]] <= tolP && #1[[1,3]] <= tolSV && #1[[1,4]] <= tolTP && 
        #1[[1,5]] <= tolTS & ]; Return[{datatb1, tolP, tolSV, tolTP, tolTS}]]

SelectData[dir_, fnm_, numrecs_, wavelen_, tolP_, tolSV_, tolTP_, tolTS_] := 
  Block[{datatb, i, datatb1, fs, tol, n}, 
   fs = OpenRead[StringJoin[dir, fnm]]; datatb = Table[0, {numrecs}]; 
    For[i = 1, i <= numrecs, i++, datatb[[i]] = 
      Read[fs, {Table[Number, {7}], Table[Number, {wavelen}]}]]; Close[fs]; 
    tol = {tolP, tolSV, tolTP, tolTS}; n = {0, 0, 0, 0}; 
    For[i = 1, i <= Length[datatb], i++, For[j = 2, j <= 5, j++, 
      If[datatb[[i,1,j]] <= tol[[j - 1]], n[[j - 1]]++]]]; Print[n]; 
    datatb1 = Select[datatb, #1[[1,2]] <= tolP && #1[[1,3]] <= tolSV && 
        #1[[1,4]] <= tolTP && #1[[1,5]] <= tolTS & ]; Return[datatb1]]

WavHist[dtb_, ymin_, ymax_] := Block[{ny = 50, th, i, j, wavelen}, 
   wavelen = Length[dtb[[1]]]; th = Table[0, {ny}, {wavelen}]; 
    dy = (ymax - ymin)/ny; For[j = 1, j <= Length[dtb], j++, 
     For[i = 1, i <= wavelen, i++, If[Max[dtb[[j,i]]] < ymax - dy && 
        Min[dtb[[j,i]]] > ymin + dy, th[[Quotient[dtb[[j,i]] - ymin, dy] + 1,
         i]]++]]]; Return[th]]

GetMeanData[data_] := Block[{mea, stdev}, mea = Plus @@ data/Length[data]; 
    stdev = Sqrt[Plus @@ ((#1 - mea)^2 & ) /@ data/Length[data]]; 
    Return[{mea, stdev}]]



{gp, Lengthtb, t1, tbx, tb} = ReadObs[dir0, "p_obs"]; t2 = tbx[[-1]]; 

{datatb1, tolP, tolSV, tolTP, tolTS} = SelectData[dir0, "p_syn", 
    numrecs = 5000, Lengthtb, rat]; Print[Length[datatb1]];
(*
dtbp = SelectData[dir0, "p_syn", numrecs = 5000, Lengthtb, tolP, tolSV, tolTP=100000., 
    tolTS=100000.]; Print[Length[dtbp]];
*)

dtbp = datatb1;



dtb1p = SelectData[dir1, "p_syn", numrecs, Lengthtb, tolP, tolSV, tolTP, 
    tolTS]; Print[Length[dtb1p]];

dtb2p = SelectData[dir2, "p_syn", numrecs, Lengthtb, tolP, tolSV, tolTP, 
    tolTS]; Print[Length[dtb2p]];

dtb3p = SelectData[dir3, "p_syn", numrecs, Lengthtb, tolP, tolSV, tolTP, 
    tolTS]; Print[Length[dtb3p]];

dtbtot = Join[dtbp, dtb1p, dtb2p, dtb3p]; 

totlen = Length[dtbtot];Print["totlen =",totlen];

{hmin, hmax} = {Min[(Min[#1[[2]]] & ) /@ dtbtot], 
    Max[(Max[#1[[2]]] & ) /@ dtbtot]}; 

th = WavHist[Transpose[dtbtot][[2]], hmin, hmax]; 

th0 = th*(1000./Length[dtbtot]); 

ghp = ListContourPlot[N[Log[th0 + 1]], AspectRatio -> 1/5, 
    ColorFunction -> clf, Contours -> Table[i, {i, 0, 6, 6/15.}], 
    ColorFunctionScaling -> True, ContourLines -> False, 
    MeshRange -> {{t1, t2}, {hmin, hmax}}, PlotRange -> {0, 6}, 
    TextStyle -> {FontFamily -> "Swiss721BT-Roman", FontSize -> 8}, 
    DisplayFunction -> Identity, ImageSize -> 500]; 
(*
hp = Show[ghp, gp, DisplayFunction -> $DisplayFunction, 
    Frame -> {True, None, None, None}, FrameTicks -> 
     {Table[If[Mod[i, 5] == 0, {i, i, {0, 0.02}, {athick}}, 
        {i, "", {0, 0.01}, {athick}}], {i, -9, 40, 1}], None, None, None}, 
    FrameStyle -> {athick}, ImageSize -> {100, 100}, AspectRatio -> 0.9, 
    PlotRange -> 1.1*{hmin, hmax}, Epilog -> 
     {athick, Line[{{xmin = t1, ymin = hmin}, {xmin, ymin + 0.1}}], 
      Line[{{xmin - 0.2, ymin}, {xmin + 0.1, ymin}}], 
      Line[{{xmin - 0.2, ymin + 0.1}, {xmin + 0.1, ymin + 0.1}}], 
      Text[0.1, {xmin + 2.5, ymin + 0.03}]}]; 
*)
hp=Show[ghp,gp,DisplayFunction->$DisplayFunction,Frame->{True,True,None,None},FrameTicks->{Table[If[Mod[i,10]==0,{i,i,{0.02,0},{athick}},{i,"",{0.01,0},{athick}}],{i,-10,39,5}],{{-.4,"-0.4",{0.012,0},{athick}},{-.3,"-0.3",{0.012,0},{athick}},{-.2,"-0.2",{0.012,0},{athick}},{-.1,"-0.1",{0.012,0},{athick}},{0,"0",{0.012,0},{athick}},{.1,"0.1",{0.012,0},{athick}},{.2,"0.2",{0.012,0},{athick}},{.3,"0.3",{0.012,0},{athick}},{.4,"0.4",{0.012,0},{athick}}},None,None},FrameStyle->{athick},ImageSize->{100,100},AspectRatio->1.0,PlotRange->{{t1-1,t2+1},1.07*{hmin,hmax}},Epilog->{AbsoluteThickness[1],Line[{{-5,0},{40,0}}],Line[{{0,-0.5},{0,0.5}}]}];



{mea, stdev} = GetMeanData[Transpose[dtbtot][[2]]];

Print["Psd=",Plus@@stdev/Length[stdev]];

mhp = Show[gp, MultipleListPlot[Transpose[{tbx, mea}], 
     Transpose[{tbx, mea + stdev}], Transpose[{tbx, mea - stdev}], 
     PlotJoined -> True, GridLines -> None, SymbolShape -> None, 
     PlotStyle -> {{Hue[1], Thickness[0.005]}, {Hue[2/3], Thickness[0.001]}, 
       {Hue[2/3], Thickness[0.001]}}, DisplayFunction -> Identity], 
    TextStyle -> {FontSize -> 12, FontFamily -> "Swiss721BT-Roman"}, 
    GridLines -> None, Axes -> None, Frame -> {True, None, None, None}, 
    FrameStyle -> {Thickness[0.005]}, FrameTicks -> 
     {Table[If[Mod[i, 3] == 0, {i, i, {0, 0.01}, {Thickness[0.005]}}, 
        {i, "", {0, 0.005}, {Thickness[0.005]}}], {i, -9, 30, 1}], None, 
      None, None}, ImageSize -> 500, PlotRange -> 1.1*{hmin, hmax},
       DisplayFunction -> Identity]; 



{gs, Lengthtb, t1, tbx, tb} = ReadObs[dir0, "s_obs"]; t2 = tbx[[-1]]; 

dtbs = SelectData[dir0, "s_syn", numrecs, Lengthtb, tolP, tolSV, tolTP, 
    tolTS]; 

dtb1s = SelectData[dir1, "s_syn", numrecs, Lengthtb, tolP, tolSV, tolTP, 
    tolTS];

dtb2s = SelectData[dir2, "s_syn", numrecs, Lengthtb, tolP, tolSV, tolTP, 
    tolTS]; 

dtb3s = SelectData[dir3, "s_syn", numrecs, Lengthtb, tolP, tolSV, tolTP, 
    tolTS]; 

dtbtot = Join[dtbs, dtb1s, dtb2s, dtb3s]; 

{hmin, hmax} = {Min[(Min[#1[[2]]] & ) /@ dtbtot], 
    Max[(Max[#1[[2]]] & ) /@ dtbtot]}; 

th = WavHist[Transpose[dtbtot][[2]], hmin, hmax]; 

th0 = th*(1000./Length[dtbtot]); 

ghs = ListContourPlot[N[Log[th0 + 1]], AspectRatio -> 1/5, 
    ColorFunction -> clf, Contours -> Table[i, {i, 0, 6, 6/15.}], 
    ColorFunctionScaling -> True, ContourLines -> False, 
    MeshRange -> {{t1, t2}, {hmin, hmax}}, PlotRange -> {0, 6}, 
    TextStyle -> {FontFamily -> "Swiss721BT-Roman", FontSize -> 8}, 
    DisplayFunction -> Identity, ImageSize -> 500]; 
(*
hs = Show[ghs, gs, DisplayFunction -> $DisplayFunction, 
    Frame -> {True, None, None, None}, FrameTicks -> 
     {Table[If[Mod[i, 5] == 0, {i, i, {0, 0.014}, {athick}}, 
        {i, "", {0, 0.007}, {athick}}], {i, -51, 7, 1}], None, None, None}, 
    FrameStyle -> {athick}, ImageSize -> {153.5, 100}, AspectRatio -> 0.6, 
    PlotRange -> 1.1*{hmin, hmax}, Epilog -> 
     {athick, Line[{{t2, ymin = hmin}, {t2, ymin + 0.1}}], 
      Line[{{t2 - 0.2, ymin}, {t2 + 0.1, ymin}}], 
      Line[{{t2 - 0.2, ymin + 0.1}, {t2 + 0.1, ymin + 0.1}}], 
      Text[0.1, {t2 - 2, ymin + 0.05}]}]; 
*)

hs=Show[ghs,gs,DisplayFunction->$DisplayFunction,Frame->{True,None,None,True},FrameTicks->{Table[If[Mod[i,10]==0,{i,i,{0.012,0},{athick}},{i,"",{0.007,0},{athick}}],{i,-50,7,5}],None,None,{{-.2,"-0.2",{0.006,0},{athick}},{-.1,"-0.1",{0.006,0},{athick}},{0,"0",{0.006,0},{athick}},{.1,"0.1",{0.006,0},{athick}},{.2,"0.2",{0.006,0},{athick}}}},FrameStyle->{athick},ImageSize->{153.5,100},AspectRatio->0.6,PlotRange->{{t1-1,t2+1},1.1*{hmin,hmax}},Epilog->{AbsoluteThickness[1],Line[{{-50,0},{5,0}}],Line[{{0,-0.5},{0,0.5}}]}];


{mea, stdev} = GetMeanData[Transpose[dtbtot][[2]]]; 

Print["Ssd=",Plus@@stdev/Length[stdev]];

mhs = Show[gs, MultipleListPlot[Transpose[{tbx, mea}], 
     Transpose[{tbx, mea + stdev}], Transpose[{tbx, mea - stdev}], 
     PlotJoined -> True, GridLines -> None, SymbolShape -> None, 
     PlotStyle -> {{Hue[1], Thickness[0.005]}, {Hue[2/3], Thickness[0.001]}, 
       {Hue[2/3], Thickness[0.001]}}, DisplayFunction -> Identity], 
    TextStyle -> {FontSize -> 12, FontFamily -> "Swiss721BT-Roman"}, 
    GridLines -> None, Axes -> None, Frame -> {True, None, None, None}, 
    FrameTicks -> {Table[If[Mod[i, 5] == 0, {i, i, {0, 0.01}, 
         {Thickness[0.005]}}, {i, "", {0, 0.005}, {Thickness[0.005]}}], 
       {i, -41, 7, 1}], None, None, None}, FrameStyle -> {Thickness[0.005]}, 
    ImageSize -> 500, PlotRange -> 1.1*{hmin, hmax}, DisplayFunction -> Identity]; 


tbresP=#[[1,6]]&/@ dtbtot;
tbresS=#[[1,7]]&/@ dtbtot;
meanresP=Plus@@tbresP/Length[tbresP];
meanresS=Plus@@tbresS/Length[tbresS];
devresP=Sqrt[Plus@@((tbresP-meanresP)^2)/Length[tbresP]];
devresS=Sqrt[Plus@@((tbresS-meanresS)^2)/Length[tbresS]];


SelectModels[dir_, fnm_, numrecs_, rat_] := 
  Block[{datatb, i, tolP, tolSV, tolTP, tolTS, datatb1, fs, ndata, numrows, 
    numcols = 3, recordtype}, fs = OpenRead[StringJoin[dir, fnm]]; 
    ndata = Read[fs, Number]; numrows = Read[fs, Number]; 
    recordtype = {Table[Number, {7}], Table[Number, {numrows}, {numcols}]}; 
    Skip[fs, recordtype, ndata - numrecs]; datatb = Table[0, {numrecs}]; 
    For[i = 1, i <= numrecs, i++, datatb[[i]] = Read[fs, recordtype]]; 
    Close[fs]; tolP = Sort[Transpose[Transpose[datatb][[1]]][[2]]][[
      Round[numrecs/rat]]]; 
    tolSV = Sort[Transpose[Transpose[datatb][[1]]][[3]]][[
      Round[numrecs/rat]]]; 
    tolTP = Sort[Transpose[Transpose[datatb][[1]]][[4]]][[
      Round[numrecs/rat]]]; 
    tolTS = Sort[Transpose[Transpose[datatb][[1]]][[5]]][[
      Round[numrecs/rat]]]; datatb1 = Select[datatb, 
      #1[[1,2]] <= tolP && #1[[1,3]] <= tolSV && #1[[1,4]] <= tolTP && 
        #1[[1,5]] <= tolTS & ]; Return[datatb1]]

SelectModels[dir_, fnm_, numrecs_, tolP_, tolSV_, tolTP_, tolTS_] := 
  Block[{datatb, i, datatb1, fs, ndata, numrows, numcols = 3, recordtype}, 
   fs = OpenRead[StringJoin[dir, fnm]]; ndata = Read[fs, Number]; 
    numrows = Read[fs, Number]; recordtype = {Table[Number, {7}], 
      Table[Number, {numrows}, {numcols}]}; Skip[fs, recordtype, 
     ndata - numrecs]; datatb = Table[0, {numrecs}]; 
    For[i = 1, i <= numrecs, i++, datatb[[i]] = Read[fs, recordtype]]; 
    Close[fs]; datatb1 = Select[datatb, 
      #1[[1,2]] <= tolP && #1[[1,3]] <= tolSV && #1[[1,4]] <= tolTP && 
        #1[[1,5]] <= tolTS & ]; Return[datatb1]]

pict2 = Compile[{{x, _Real, 1}, {y, _Real, 1}, {b, _Real, 1}, 
     {n, _Integer, 1}, {mtr1, _Real, 2}}, 
    Block[{pc, dpt0, dpt1, dpt2, ix, iy, dx, dy, i, j, trc, mtr}, 
     mtr = mtr1; dx = (b[[2]] - b[[1]])/(n[[1]] - 1); 
      dy = (b[[4]] - b[[3]])/(n[[2]] - 1); ix = Round[(x - b[[1]])/dx] + 1; 
      iy = Round[(y - b[[3]])/dy] + 1; pc = Flatten[Transpose[{ix, ix}]]; 
      dpt0 = Prepend[iy, 1]; dpt1 = Flatten[Transpose[{dpt0, dpt0}]]; 
      dpt2 = Take[dpt1, {2, -2}]; trc = Transpose[{pc, dpt2}]; 
      For[j = 1, j < Length[trc] - 1, j++, 
       For[i = trc[[j,2]], i < trc[[j + 1,2]], i++, mtr[[i,trc[[j,1]]]]++]; 
        If[trc[[j + 1,1]] < trc[[j + 2,1]], For[i = trc[[j + 1,1]], 
          i < trc[[j + 2,1]], i++, mtr[[trc[[j + 1,2]],i]]++], 
         For[i = trc[[j + 1,1]], i > trc[[j + 2,1]], i--, 
          mtr[[trc[[j + 1,2]],i]]++]]]; j = Length[trc] - 1; 
      For[i = trc[[j,2]], i <= trc[[j + 1,2]], i++, mtr[[i,trc[[j,1]]]]++]; 
      Return[mtr]]]; 

ModHist[s1_, {xiz_, xaz_, yin_, yax_}, wavtype_] := 
  Block[{nx = 40, ny, mtr, dpt, dpt1, i, j, numrows}, 
   numrows = Length[s1[[1,2]]]; ny = 4*nx; mtr = Table[0, {ny}, {nx}]; 
    If[wavtype == "p", For[j = 1, j <= Length[s1], j++, 
      mtr = pict2[Transpose[s1[[j,2]]][[1]], 
        dpt = 0; dpt1 = Table[dpt += Transpose[s1[[j,2]]][[3]][[i]], 
           {i, numrows}], {xiz, xaz, yin, yax}, {nx, ny}, mtr]], 
     If[wavtype == "s", For[j = 1, j <= Length[s1], j++, 
       mtr = pict2[Transpose[s1[[j,2]]][[1]]/Transpose[s1[[j,2]]][[2]], 
         dpt = 0; dpt1 = Table[dpt += Transpose[s1[[j,2]]][[3]][[i]], 
            {i, numrows}], {xiz, xaz, yin, yax}, {nx, ny}, mtr]], 
      For[j = 1, j <= Length[s1], j++, mtr = pict2[Transpose[s1[[j,2]]][[2]], 
         dpt = 0; dpt1 = Table[dpt += Transpose[s1[[j,2]]][[3]][[i]], 
            {i, numrows}], {xiz, xaz, yin, yax}, {nx, ny}, mtr]]]]; 
    Return[mtr]]

GetMedian[s1_] := Block[{s10, i, j, tmp, s2, lens1, numrows, med, mad}, 
   numrows = Length[s1[[1,2]]]; lens1 = Length[s1]; s10 = Transpose[s1][[2]]; 
    For[i = 1, i <= Length[s10], i++, s10[[i]] = 
      Transpose[{Transpose[s10[[i]]][[1]], Transpose[s10[[i]]][[1]]/
         Transpose[s10[[i]]][[2]], Transpose[s10[[i]]][[3]], 
        tmp = 0; -Table[tmp += Transpose[s10[[i]]][[3,j]], {j, numrows}], 
        Transpose[s10[[i]]][[2]]}]]; s2 = Transpose[s10, {3, 1, 2}]; 
    med = Map[Sort[#1][[Round[lens1/2.] + 1]] & , s2, {2}]; 
    mad = Plus @@ (Abs[#1 - med] & ) /@ s10/Length[s10]; Return[{med, mad}]]

bound[zin_, zax_, hin_, hax_, numrows_] := 
   Block[{tmp, din, dax, fns, fnn, dps, zin1, zax1, dpx}, 
    tmp = 0; dax = -Table[tmp += hax[[i]], {i, numrows}]; tmp = 0; 
     din = -Table[tmp += hin[[i]], {i, numrows}]; 
     fns = Join[{{zax[[1]], 0, dax[[1]]}}, Table[{zax[[i]], din[[i - 1]], 
         dax[[i]]}, {i, 2, Length[din]}]]; 
     fnn = Join[{{zin[[1]], 0, dax[[1]]}}, Table[{zin[[i]], din[[i - 1]], 
         dax[[i]]}, {i, 2, Length[din]}]]; 
     dps = Reverse[Sort[Join[{0}, Table[din[[i]], {i, Length[din] - 1}], 
         Table[dax[[i]], {i, Length[din]}]]]]; 
     Return[{zin1 = Table[Min[Transpose[Select[fnn, #1[[2]] >= dps[[i]] && 
               dps[[i + 1]] >= #1[[3]] & ]][[1]]], {i, Length[dps] - 1}], 
       zax1 = Table[Max[Transpose[Select[fns, #1[[2]] >= dps[[i]] && 
               dps[[i + 1]] >= #1[[3]] & ]][[1]]], {i, Length[dps] - 1}], 
       dpx = Drop[dps, 1]}]]; 

pict[x_, dpt_, dash_, thi_, col_] := Block[{pc, dpt0, dpt1, dpt2}, 
    pc = Flatten[Transpose[{x, x}]]; dpt0 = Prepend[dpt, 0]; 
     dpt1 = Flatten[Transpose[{dpt0, dpt0}]]; dpt2 = Take[dpt1, {2, -2}]; 
     Show[Graphics[{dash, thi, Hue[0, 0, col], Line[Transpose[{pc, dpt2}]]}], 
      AspectRatio -> 2, PlotRange -> {{xiz, xaz}, {yin, -yax}}, 
      Frame -> True, GridLines -> Automatic, FrameTicks -> Automatic, 
      DisplayFunction -> Identity]]; 

pict[x_, dpt_, col_] := Block[{pc, dpt0, dpt1, dpt2}, 
    pc = Flatten[Transpose[{x, x}]]; dpt0 = Prepend[dpt, 0]; 
     dpt1 = Flatten[Transpose[{dpt0, dpt0}]]; dpt2 = Take[dpt1, {2, -2}]; 
     Show[Graphics[{athick, col, Line[Transpose[{pc, dpt2}]]}], 
      AspectRatio -> 2, PlotRange -> {{xiz, xaz}, {yin, -yax}}, 
      Frame -> True, GridLines -> Automatic, FrameTicks -> Automatic, 
      DisplayFunction -> Identity]]; 

pict[x_, dpt_, col_, thi_] := Block[{pc, dpt0, dpt1, dpt2}, 
    pc = Flatten[Transpose[{x, x}]]; dpt0 = Prepend[dpt, 0]; 
     dpt1 = Flatten[Transpose[{dpt0, dpt0}]]; dpt2 = Take[dpt1, {2, -2}]; 
     Show[Graphics[{thi, col, Line[Transpose[{pc, dpt2}]]}], 
      AspectRatio -> 2, PlotRange -> {{xiz, xaz}, {yin, -yax}}, 
      Frame -> True, GridLines -> Automatic, FrameTicks -> Automatic, 
      DisplayFunction -> Identity]]; 

GetLimits[dir_, proj_, numrows_] := Block[{fan, str, tb1, hin, hax, zin, zax, 
    nin, nax, h, vs, vin, vax}, fan = OpenRead[StringJoin[dir, proj, ".rf"]]; 
    Table[str = Read[fan, String], {37}]; 
    tb1 = Read[fan, Table[Number, {numrows}, {11}]]; Close[fan]; 
    hin = Transpose[tb1][[8]]; hax = Transpose[tb1][[10]]; 
    zin = Transpose[tb1][[1]]; 
    zax = Transpose[tb1][[3]]; 
    nin = Transpose[tb1][[4]]; 
    nax = Transpose[tb1][[6]]; 
    vin = Transpose[tb1][[1]]/Transpose[tb1][[6]]; 
    vax = Transpose[tb1][[3]]/Transpose[tb1][[4]]; 
Return[{hin, hax, zin, zax, nin, nax, vin, 
      vax}]];

GetRes[dir_, proj_] := Block[{fan, str, resP, resS}, 
   fan = OpenRead[StringJoin[dir, proj, ".rf"]]; 
    Table[str = Read[fan, String], {22}]; str = Read[fan, Word]; 
    If[str == "%", Read[fan, String]; resP = "no", 
     Table[str = Read[fan, Word], {6}]; Read[fan, Word]; resP = str]; 
    str = Read[fan, Word]; If[str == "%", Read[fan, String]; resS = "no", 
     Table[str = Read[fan, Word], {6}]; Read[fan, Word]; resS = str]; 
    Close[fan]; Return[{resP, resS}]]

dptiasp = -{0., 10., 20., 20., 35., 35., 71., 120., 171., 210., 210., 271., 
     371., 410., 410.}; 
vpiasp = {5.8, 5.8, 5.8, 6.5, 6.5, 8.04, 8.044, 8.05, 8.192, 8.3, 8.3, 8.523, 
    8.888, 9.03, 9.36}; 
vsiasp = {3.36, 3.36, 3.36, 3.75, 3.75, 4.47, 4.483, 4.5, 4.51, 4.518, 4.522, 
    4.628, 4.802, 4.87, 5.07}; 

vpvsiasp = vpiasp/vsiasp; 

gvsiasp = Show[Graphics[{athick, Line[Transpose[{vsiasp, dptiasp}]]}], 
    DisplayFunction -> Identity]; 

gvpiasp = Show[Graphics[{athick, Line[Transpose[{vpiasp, dptiasp}]]}], 
    DisplayFunction -> Identity]; 

gvpvsiasp = Show[Graphics[{athick, Line[Transpose[{vpvsiasp, dptiasp}]]}], 
    DisplayFunction -> Identity]; 



dtbm = SelectModels[dir0, "model", numrecs, tolP, tolSV, tolTP, tolTS]; 
  Length[dtbm]

dtb1m = SelectModels[dir1, "model", numrecs, tolP, tolSV, tolTP, tolTS]; 
  Length[dtb1m]

dtb2m = SelectModels[dir2, "model", numrecs, tolP, tolSV, tolTP, tolTS]; 
  Length[dtb2m]

dtb3m = SelectModels[dir3, "model", numrecs, tolP, tolSV, tolTP, tolTS]; 
  Length[dtb3m]

dtbtot = Join[dtbm, dtb1m, dtb2m, dtb3m]; 

{med, mad} = GetMedian[dtbtot]; 

numrows = Length[dtbtot[[1,2]]]; tmp = 0; 
  dptmed = -Table[tmp += Transpose[med][[3,i]], {i, numrows}]; 

{hin, hax, zin, zax, nin, nax, vin, vax} = GetLimits[dir0, proj, numrows]; 

{resP, resS} = GetRes[dir0, proj]; 



yax = Ceiling[Max[(Plus @@ Transpose[#1[[2]]][[3]] & ) /@ dtbtot]]; 

mtr = ModHist[dtbtot, {xiz = 3.6, xaz = 10.2, yin = 0, yax}, "p"]; 

mtr0 = mtr*(1000./Length[dtbtot]); 
tb11p = Log[mtr0 + 1]; 
maxp = Max[tb11p]; 

maxps = Max[maxp]; 
pltranz = {0, 7}; 
cnts = Table[i, {i, 0, 6, 6/15}]; 
colfun = If[#1 == 0, Hue[0, 0, 1], Hue[0.75*(1 - #1)]] & ; 
cntlins = False; 
fontsize = 8; 
frmwidth = athick; 

g10p = ListContourPlot[Reverse[tb11p], MeshRange -> 
     {{xiz, xaz}, {yin, -yax}}, Contours -> cnts, ColorFunction -> clf, 
    Frame -> True, FrameStyle -> athick, TextStyle -> 
     {FontSize -> fontsize, FontFamily -> "Swiss721BT-Roman"}, 
    FrameTicks -> {None, yticks1 = Table[{-i, If[Mod[i, 40] == 0, -i, ""], 
         If[Mod[i, 10] == 0, {0.01, 0}, {0.003, 0}]}, {i, 0, yax, 5}], 
      xticks = Table[{i, If[Mod[i, 1] == 0, Round[i], ""]}, 
        {i, xiz, xaz, 0.5}], None}, ContourLines -> cntlins, 
    PlotRange -> {{xiz - 0.2, xaz + 0.2}, {yin + 2, dptrng}, pltranz}, 
    DisplayFunction -> Identity]; 

gmedp = pict[Transpose[med][[1]], Transpose[med][[4]], adash, athick, 0]; 

{zin1, zax1, dpx} = bound[zin, zax, hin, hax, numrows]; 

gx = pict[zax1, dpx, Hue[1]]; 
gn = pict[zin1, dpx, Hue[1]]; 

gph = Show[g10p, (*gmedp,*) gx, gn, gvpiasp, Frame -> {None, True, True, None}, 
    FrameTicks -> {None, yticks = Table[If[Mod[i, 20] == 0, 
         {i, -i, {0, 0.015}, {athick}}, {i, "", {0, 0.007}, {athick}}], 
        {i, -450, 0, 10}], xticks = Table[If[Mod[Rationalize[i], 1] == 0, 
         {i, Rationalize[i], {0, 0.015}, {athick}}, {i, "", {0, 0.01}, 
          {athick}}], {i, 3, 10, 0.5}], None}, DisplayFunction -> 
     Identity, ImageSize -> {100., 245.}, AspectRatio -> 2.5]; 

lst = {}; gph /. {Hue[x_] :> (lst = Append[lst, x])}; lst = Union[lst]

lst = Drop[lst, -3]

lgnd[x_, y_, dx_, dy_] := Table[{Hue[lst[[-i]]], 
    Rectangle[{x + dx*(i - 1), y}, {x + dx*i, y + dy}]}, {i, 1, Length[lst]}]



mtr = ModHist[dtbtot, {xin = 1.5, xan = 5.3, yin, yax}, "s"]; 

mtr0 = mtr*(1000./Length[dtbtot]); 
tb11p = Log[mtr0 + 1]; 
maxp = Max[tb11p]; 

maxps = Max[maxp]; 
pltranz = {0, 7}; 
cnts = Table[i, {i, 0, 6, 6./15}]; 
colfun = If[#1 == 0, Hue[0, 0, 1], Hue[0.75*(1 - #1)]] & ; 
cntlins = False; 

g10s = ListContourPlot[Reverse[tb11p], MeshRange -> 
     {{xin, xan}, {yin, -yax}}, Contours -> cnts, ColorFunction -> clf, 
    Frame -> True, FrameStyle -> athick, TextStyle -> 
     {FontSize -> fontsize, FontFamily -> "Swiss721BT-Roman"}, 
    FrameTicks -> {None, yticks1 = Table[{-i, If[Mod[i, 40] == 0, i, ""], 
         If[Mod[i, 10] == 0, {0.01, 0}, {0.003, 0}]}, {i, 0, yax, 5}], 
      xticks = Table[{i, If[Mod[i, 1] == 0, Round[i], ""]}, {i, 2, 5, 0.5}], 
      None}, ContourLines -> cntlins, PlotRange -> 
     {{xin, xan}, {yin + 2, dptrng}, pltranz}, DisplayFunction -> Identity]; 

gmeds = pict[Transpose[med][[2]], Transpose[med][[4]], adash, athick, 0]; 

{nin1, nax1, dpx} = bound[nin, nax, hin, hax, numrows]; 


gx = pict[nax1, dpx, Hue[1]]; 
gn = pict[nin1, dpx, Hue[1]]; 

gsh = Show[g10s, (*gmeds,*) gx, gn, gvsiasp, Frame -> {None, None, True, None},
 	FrameTicks -> {None, yticks = Table[If[Mod[i, 50] == 0,
     {i, -i, {0, 0.015}, {athick}}, {i, "", {0, 0.007}, {athick}}], 
        {i, -450, 0, 10}], xticks = Table[If[Mod[Rationalize[i], 1] == 0, 
         {i, Rationalize[i], {0, 0.015}, {athick}}, {i, "", {0, 0.01}, 
          {athick}}], {i, 1.5, 5.5, 0.5}], None}, 
    DisplayFunction -> Identity, ImageSize -> {80., 245.}, 
    AspectRatio ->(*2.87*)2.3]; 



mtr = ModHist[dtbtot, {xiv = 0.97, xav = 4.07, yin-1.0, yax}, "vp/vs"]; 

mtr0 = mtr*(1000./Length[dtbtot]); 
tb11p = Log[mtr0 + 1]; 
maxp = Max[tb11p]; 

maxps = Max[maxp]; 
pltranz = {0, 7}; 
cnts = Table[i, {i, 0, 6, 6/15.}]; 
colfun = If[#1 == 0, Hue[0, 0, 1], Hue[0.75*(1 - #1)]] & ; 
cntlins = False; 

g10v = ListContourPlot[Reverse[tb11p], MeshRange -> 
     {{xiv, xav}, {yin, -yax}}, Contours -> cnts, ColorFunction -> clf, 
    Frame -> True, FrameStyle -> athick, TextStyle -> 
     {FontSize -> fontsize, FontFamily -> "Swiss721BT-Roman"}, 
    FrameTicks -> {None, yticks1 = Table[{-i, If[Mod[i, 40] == 0, i, ""], 
         If[Mod[i, 10] == 0, {0.01, 0}, {0.003, 0}]}, {i, 0, yax, 5}], 
      xticks = Table[{i, If[Mod[i, 1] == 0, Round[i], ""]}, {i, 1, 5, 0.5}], 
      None}, ContourLines -> cntlins, PlotRange -> 
     {{xiv- 0.02, xav - 0.01}, {yin + 2, dptrng}, pltranz}, 
    DisplayFunction -> Identity]; 

gmedv = pict[Transpose[med][[5]], Transpose[med][[4]], adash, athick, 0]; 

{vin1, vax1, dpx} = bound[vin, vax, hin, hax, numrows]; 
gx = pict[vax1, dpx, Hue[1]]; 
gn = pict[vin1, dpx, Hue[1]]; 

mn = Transpose[med][[5]] - Transpose[mad][[5]]; 
mx = Transpose[med][[5]] + Transpose[mad][[5]]; 
hn = Transpose[med][[3]] - Transpose[mad][[3]]; 
hx = Transpose[med][[3]] + Transpose[mad][[3]]; 

{ain1, aax1, px} = bound[mn, mx, hn, hx, numrows]; 
gmx = pict[aax1, px, Hue[0.8], AbsoluteThickness[1]]; 
gmn = pict[ain1, px, Hue[0.8], AbsoluteThickness[1]]; 

gvh = Show[g10v, (*gmedv,*) gx, gn, gvpvsiasp, Frame -> {None, None, True, None}, 
    FrameTicks -> {None, yticks = Table[If[Mod[i, 50] == 0,
     {i, -i, {0, 0.015}, {athick}}, {i, "", {0, 0.007}, {athick}}], 
        {i, -450, 0, 10}], xticks = 
       Table[If[i == 1.0 || i == 2.0 || i == 3.0 || i == 4.0, {i, Round[i], {0, 0.02}, 
          {athick}}, {i, "", {0, 0.01}, {athick}}], {i, 1.0, 5.0, 0.5}], 
      None}, DisplayFunction -> Identity, ImageSize -> {120, 245.}, 
    AspectRatio -> 1.7]; 

<<"Graphics`Graphics`";
resgr=Show[Graphics[GraphicsArray[{{Histogram[tbresP,DisplayFunction->Identity,TextStyle->{FontSize->8,FontFamily->"Swiss721BT-Roman"},PlotLabel->"Pres: obs="<>ToString[resP(*"no"*)]<>", syn="<>ToString[FortranForm[SetAccuracy[meanresP, 3]]]<>"/"<>ToString[SetAccuracy[3 devresP, 2]],AspectRatio->.5,HistogramCategories->30,HistogramRange->{Floor[Min[tbresP]],Ceiling[Max[tbresP]]},Ticks->{Table[i, {i,-10,10,1}],None},Axes->{True,False}],Histogram[tbresS,DisplayFunction->Identity,TextStyle->{FontSize->8,FontFamily->"Swiss721BT-Roman"},PlotLabel->"  Sres: obs="<>ToString[resS(*"no"*)]<>", syn="<>ToString[FortranForm[SetAccuracy[meanresS, 3]]]<>"/"<>ToString[SetAccuracy[3 devresS, 2]],AspectRatio->.5,HistogramCategories->30,HistogramRange->{Floor[Min[tbresS]],Ceiling[Max[tbresS]]},Ticks->{Table[i, {i,-10,10,1}],None},Axes->{True,False}]}},GraphicsSpacing->0]],ImageSize->{272.5,85},AspectRatio->0.29];


g3 = Show[Graphics[{Rectangle[{0, 0}, {200, 490}, gph], 
      Rectangle[{210, 0}, {350, 490}, gsh], Rectangle[{350, 0}, 
       {579, 490}, gvh], Rectangle[{8, -220}, {208, -20}, hp], 
      Rectangle[{228, -220}, {535, -20}, hs], Rectangle[{45, 85}, {140, 95}, 
       Graphics[{lgnd[1, 1, 1, 1]}, AspectRatio -> 1/7]], 
      Text[" \!\(10\^2\)  \!\(10\^3\)  \!\(10\^4\)", {95, 105}], 
      Text["Vp (km/s)", {130, 500}], Text["Vs (km/s)", {270, 500}], 
      Text["Vp/Vs", {460, 500}], Text["Depth (km)", {60, 250}, {0, 0}, 
       {0, 1}], Text["Time(s)", {100, -230}], Text["Time(s)", {400, -230}], 
      Text["PRF", {100, -15}], Text["SRF", {400, -15}], Text["", {20, 500}], 
      Text["", {255, 500}], Text["", {465, 500}], Text["", {20, -15}], 
      Text["", {250, -15}], Text[StringJoin["", proj], {250, 50}]}], 
    TextStyle -> {FontSize -> 8, FontFamily -> "Swiss721BT-Roman"}, 
    ImageSize -> {272.5, 355.}, AspectRatio -> 710/545., 
    DisplayFunction -> $DisplayFunction]; 


StringJoin[outfil, ".m"]
Put[g3, "res0ST24s.m"];

g4 = Show[Graphics[{Rectangle[{0, 0}, {272.5, 355.}, g3], 
     Rectangle[{0, -85}, {272.5, 0}, resgr]}], 
   ImageSize -> {272.5, 440}, AspectRatio -> 440/272.5];

Export["res0ST24s.eps", g4];
Export["gph.eps", gph];
Export["gvh.eps", gvh];
Export["gsh.eps", gsh];
Export["hs.eps", hs];
Export["hp.eps", hp];
Export["resgr.eps", resgr];

prf = Show[Graphics[{Rectangle[{0, 0}, {200, 180}, hp], Text["PRF", {80, 190}]}], TextStyle -> {FontSize -> 10, FontFamily -> "Swiss721BT-Roman"}, ImageSize -> {200, 180}, AspectRatio -> 180/200];
srf = Show[Graphics[{Rectangle[{0, 0}, {220, 180}, hs], Text["SRF", {90, 190}]}], TextStyle -> {FontSize -> 10, FontFamily -> "Swiss721BT-Roman"}, ImageSize -> {220, 180}, AspectRatio -> 180/220];
vp = Show[Graphics[{Rectangle[{0, 0}, {200, 490}, gph], Text["Vp (km/s)", {110, 495}], Text["Depth (km)", {0, 250}, {0, 0}, {0, 1}]}], TextStyle -> {FontSize -> 12, FontFamily -> "Swiss721BT-Roman"}, ImageSize -> {200, 490}, AspectRatio -> 490/200];
shear = Show[Graphics[{Rectangle[{0, 0}, {200, 490}, gsh], Text["Vs (km/s)", {110, 500}]}], TextStyle -> {FontSize -> 12, FontFamily -> "Swiss721BT-Roman"}, ImageSize -> {200, 490}, AspectRatio -> 490/200];
ratio = Show[Graphics[{Rectangle[{0, 0}, {579, 490}, gvh],Text["Vp/Vs", {285, 500}]}], TextStyle -> {FontSize -> 12, FontFamily -> "Swiss721BT-Roman"}, ImageSize -> {300, 490}, AspectRatio -> 490/300];
Export["vp.eps", vp];
Export["shear.eps", shear];
Export["ratio.eps", ratio];
Export["prf.eps", prf];
Export["srf.eps", srf];


WriteString["res0ST24s.med", 
   TableForm[Prepend[Transpose[{SetAccuracy[zin, 3], 
       SetAccuracy[Transpose[med][[1]], 3], SetAccuracy[zax, 3], 
       SetAccuracy[nin, 3], SetAccuracy[Transpose[med][[2]], 3], 
       SetAccuracy[nax, 3], Round[hin], Round[Transpose[med][[3]]], 
       Round[hax], Round[-Transpose[med][[4]]], SetAccuracy[vin, 3], 
       SetAccuracy[Transpose[med][[5]], 3], SetAccuracy[vax, 3]}], 
     {"Vp-", "Vp", "Vp+", "Vs-", "Vs", "Vs+", "H-", "H", "H+", Dpt, "Vp/Vs-", 
      "Vp/Vs", "Vp/Vs+"}], TableSpacing -> {0, 2}]]; 
  Close["res0ST24s.med"];
  
